<?php
// Sécurité : ne doit pas être exécuté s'il n'est pas lancé par un script autorisé
if ( !defined('OK') )  exit();

// Connexion à la base MySQL et vérification de la connexion
$mysqli = new mysqli($serveur,$base,$mdp,$base);
if ( $mysqli->connect_errno )
  include('../installation.php');
$mysqli->set_charset('utf8');

// Oubli d'identifiant/mot de passe -- copie dans /connect.php
if ( isset($_REQUEST['oubli']) )  {
  
  // Traitement du formulaire
  if ( isset($_REQUEST['mail']) && strlen($_REQUEST['mail']) )  {
    // Recherche du mail dans la base de données
    $resultat = $mysqli->query('SELECT id, login, mail FROM utilisateurs WHERE autorisation = 4');
    while ( $r = $resultat->fetch_assoc() )
      if ( $r['mail'] == $_REQUEST['mail'] )  {
        $utilisateur = $r;
        break;
      }
    $resultat->free();
    if ( isset($utilisateur) )  {
      // Connexion à la base de données avec les droits d'écriture
      $mysqli->close();
      $mysqli = mysql_ecriture();
      // Réinitialisation du mot de passe
      $lettres = "abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789?./,;:!";
      $mdp = '';
      for ( $i = 0; $i < 8; $i++ )
        $mdp .= substr($lettres,mt_rand(0,68),1);
      requete('utilisateurs','UPDATE utilisateurs SET genre = MOD(genre,5)+5, mdp = \''.sha1($mdp)."' WHERE id = ${utilisateur['id']}");
      // Envoi du mail
      mail($utilisateur['mail'],'[Cahier de Prépa] Modification de votre mot de passe',
"Bonjour

Vous avez demandé à modifier votre mot de passe, correspondant à l'identifiant ${utilisateur['login']}. Ce mot de passe a donc été temporairement réinitialisé à la valeur \"$mdp\". Vous devez vous connecter avec ce mot de passe et le modifier immédiatement ensuite : ce mot de passe est à usage unique et sera automatiquement effacé après votre prochaine connexion.

Cordialement,
-- 
Cahier de Prépa
","From: ne-pas-repondre@cahier-de-prepa.fr\r\nContent-type: text/plain; charset=UTF-8");
      $message = 'Le mot de passe a été réinitialisé et un mail a été envoyé.';
    }
    else
      $message = 'Le mail fourni n\'est pas dans la base de données.';
  }

  // Formulaire de récupération du mail si mdp non déjà réinitialisé
  if ( !isset($utilisateur) )  {
    $mysqli->close();
?>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01//EN" "http://www.w3.org/TR/html4/strict.dtd">
<html>
<head>
  <title>Cahier de Prépa - Oubli du mot de passe</title>
  <meta http-equiv="Content-Type" content="text/html; charset=utf-8">
  <link rel="stylesheet" href="../css/style.css" type="text/css" media="screen">
  <link rel="stylesheet" href="../css/couleurs.css" type="text/css" media="screen">
  <link rel="stylesheet" href="../css/mobile.css" type="text/css" media="handheld, only screen and (max-device-width:480px)">
</head>
<body>

<h1>Cahier de Prépa - Oubli du mot de passe</h1>
<?php 
    if ( isset($message) )
      echo "\n  <div class=\"warning\">$message</div>\n";
?>

<form class="warning" action="." method="post">
  <p>Un mail contenant l'identifiant et un nouveau mot de passe temporaire sera envoyé par mail à l'adresse ci-dessous si elle est bien enregistrée&nbsp;:</p>
  <p class="ligne"><label for="mail">Adresse mail&nbsp;: </label><input type="text" name="mail" id="mail"></p>
  <p><input type="submit" name="Ok" value="Envoyer"></p>
  <input type="hidden" name="oubli" value="1">
</form>

<h3 class="warning"><a href="http://<?php echo $site; ?>">Revenir au site public</a></h3>

</body>
</html>
<?php
    exit();
  }
}

// Si une demande de connexion est faite
elseif ( isset($_REQUEST['login']) && isset($_REQUEST['motdepasse']) )  {

  // Récupération des logins/mdp (professeurs uniquement) dans la base MySQL et comparaison
  $resultat = $mysqli->query('SELECT id, login, mdp, matieres, timeout, genre FROM utilisateurs WHERE autorisation = 4');
  if ( $resultat->num_rows )  {
    while ( $r = $resultat->fetch_assoc() )
      if ( ( $r['login'] == $_REQUEST['login'] ) && ( $r['mdp'] == sha1($_REQUEST['motdepasse']) ) )  {
        // Interdiction de garder son identifiant de session
        session_regenerate_id(true);
        $_SESSION = array();
        // Interdiction de pouvoir se connecter aux autres site sur le même serveur
        $_SESSION[md5("$site-admin")] = true;
        // Pour vérification/utilisation aux connexions ultérieures
        $_SESSION['client'] = $_SERVER['HTTP_USER_AGENT'];
        $_SESSION['ip'] = $_SERVER['REMOTE_ADDR'];
        $_SESSION['login'] = $_POST['login'];
        $_SESSION['id'] = $r['id'];
        $_SESSION['matieres'] = $r['matieres'];
        $_SESSION['timeout'] = $r['timeout'];
        $_SESSION['time'] = time()+$_SESSION['timeout'];
        $resultat->free();

        // Si genre >= 5, cela signifie qu'on a demandé une régénération de mot de passe (connect.php partie publique)
        if ( $r['genre'] >= 5 )  {
          $mysqli->close();
          $mysqli = mysql_ecriture();
          requete('utilisateurs',"UPDATE utilisateurs SET mdp='pas de mot de passe', genre=MOD(genre,5) WHERE id = ${r['id']}");
          $message = 'IMPORTANT : votre mot de passe a été réinitialisé.<br>Vous devez absolument le redéfinir maintenant, dans vos <a href="prefs">Préférences</a>.';
        }
        // Retour au script appelant
        $mysqli->close();
        return;
      }
    $resultat->free();
  }
  // Si pas d'utilisateur enregistré : retour au script d'installation
  else  {
    $mysqli->close();
    include('../installation.php');
  }
  
  // Retour au script appelé par AJAX si c'est le cas (pas d'HTML)
  if ( defined('AJAX') )  {
    $mysqli->close();
    exit(json_encode(array('etat'=>0)));
  }

  // Utilisateur inconnu ou mot de passe faux
  $message = 'Cet identifiant/mot de passe n\'est pas correct&nbsp;!';
}
// Message par défaut
else
  $message = "Vous devez vous identifier pour accéder à cette partie du site. Elle n'est accessible qu'aux professeurs.";

////////////
/// HTML ///
////////////

// Titre : on récupère celui de la première page
$resultat = $mysqli->query('SELECT titre FROM pages WHERE id = 1');
$r = $resultat->fetch_assoc();
$resultat->free();
$mysqli->close();
$t = "${r['titre']} - Interface d'administration";
?>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01//EN" "http://www.w3.org/TR/html4/strict.dtd">
<html>
<head>
  <title><?php echo $t; ?></title>
  <meta http-equiv="Content-Type" content="text/html; charset=utf-8">
  <link rel="stylesheet" href="../css/style.css" type="text/css" media="screen">
  <link rel="stylesheet" href="../css/couleurs.css" type="text/css" media="screen">
  <link rel="stylesheet" href="../css/mobile.css" type="text/css" media="handheld, only screen and (max-device-width:480px)">
</head>
<body>

<h1><?php echo $t; ?></h1>

<div class="warning"><?php echo $message; ?></div>

<form class="warning" action="" method="post">
  <p class="ligne"><label for="login">Identifiant&nbsp;: </label><input type="text" name="login" id="login"></p>
  <p class="ligne"><label for="motdepasse">Mot de passe&nbsp;: </label><input type="password" name="motdepasse" id="motdepasse"></p>
  <p><input type="submit" name="Ok" value="Envoyer"></p>
  <p id="oubli"><a href="?oubli">Identifiant ou mot de passe oublié&nbsp;?</a></p>
</form>

<h3 class="warning"><a href="http://<?php echo $site; ?>">Revenir au site public</a></h3>

</body>
</html>
<?php exit(); ?>
